#include "asm86.h"
#include "ti86asm.inc"     
     
.org _asm_exec_ram ;all programs have this 
 call _clrLCD        ;clear the screen
 ld b,24             ;load value for b 
 ld c,24             ;load value for c
Move: 
    ld hl,$0000      ;load $00 into h $00 into l
    ld (_curRow),hl  ;row $00 col $00    
    ld hl, Look      ;load Look in hl
    call _puts       ;Displays the text message
    ld ix,Howie      ;loads Howie into the ix regiter
    call PutSprite   ;this displays the sprite stored in the ix register
Keys:     
    call _getkey   
    cp K_UP
    jp z,MoveUp
    cp K_DOWN                   ;These are all of the keys
    jp z,MoveDown
    cp K_LEFT
    jp z,MoveLeft
    cp K_RIGHT
    jp z,MoveRight
    cp K_EXIT
    ret                   ;end program
    jp Keys

MoveRight:
 ld a,0              ;load 0 into a
 cp c                ;if c=a goto Move(this is done so the sprite doesn't go off the screen)
 jp z,Move          
 ld ix,Howie          ;disp sprite(this is to get rid of the old sprite) 
 call PutSprite
 dec c
 dec c        
 dec c                ;dec value of c by 8
 dec c
 dec c
 dec c
 dec c
 dec c
 jp Move            ;goto move (where it will display the sprite's new location)
MoveUp:             ;sam as above, but increases c
 ld a,56
 cp c
 jp z,Move
  ld ix,Howie
 call PutSprite
 inc c
 inc c
 inc c
 inc c
 inc c
 inc c
 inc c
 inc c
 jp Move

MoveLeft:        ;same as above
 ld a,0
 cp b
 jp z,Move
 ld ix,Howie
 call PutSprite
 dec b
 dec b
 dec b
 dec b
 dec b
 dec b
 dec b
 dec b
 jp Move

MoveDown:       ;same as above
 ld a,120
 cp b
 jp z,Move
  ld ix,Howie
 call PutSprite
 inc b
 inc b
 inc b
 inc b
 inc b
 inc b
 inc b
 inc b 
 jp Move
Howie:               ;this is the picture                    
	.db %00011000
	.db %00100100
	.db %00100100
	.db %00011000
	.db %01111110
	.db %00011000
	.db %00100100
	.db %01000010
Look:               ;this is the text
  .db "Move Howie",0      
;PutSprite routine
;Input: bc = x,y; ix = 8x8 sprite location
;Output: sprite drawn; ix points to next sprite (if your sprites follow
;          in sequence); hl and and de destroyed

PutSprite:

 ld h,63                        ;shifted to $fc with add hl,hl
 ld a,c
 add a,a                        ;a*4
 add a,a
 ld l,a
 add hl,hl                      ;hl*4 (what was c has been mlt by 16
 add hl,hl
 ld a,b                 ;a/8
 rra
 rra
 rra
 or l                           ;add to more significant bytes
 ld l,a
 ld a,7                 ;use bottom 7 bits for counter
 and b
 ld d,a                 ;save counter copy in d
 ld e,8                 ;8 rows
 push bc

ps_loop:
 ld b,d                 ;get saved bit offset in b
 ld a,(ix)                      ;get this byte of the sprite in a
 inc ix                 ;point ix to the next byte of the sprite
 ld c,0
 call bit_shift
 xor (hl)                       ;change this to or if you want
 ld (hl),a
 inc l
 ld a,(hl)
 xor c                  ;also changable to or (if you changed the first)
 ld (hl),a
 ld a,15                        ;add 15 to hl (now ready for next row)
 call add_hl_a
 dec e                  ;counter (8 rows)
 jr nz,ps_loop
 pop bc
 ret

add_hl_a:                       ;add hl,a
 add a,l
 ld l,a
 ret nc
 inc h
 ret

bit_shift:                      ;while(b=<0)
 dec b                  ; a>>c
 ret m
 srl a
 rr c
 jr bit_shift
.end